/* file: "os.h" */

/* Copyright (C) 1994-2002 by Marc Feeley, All Rights Reserved. */

#ifndef ___OS_H
#define ___OS_H

/*---------------------------------------------------------------------------*/

/* Include the header files that are available. */

#define USE_POSIX /* temporary */
//#define USE_WIN32
#define USE_TERMCAP
#define USE_TERMCAP_OR_TERMINFO
#include <curses.h>


#ifdef USE_WIN32

#define USE_GetLastError
#define USE_WSAGetLastError

#endif

#ifdef USE_POSIX

#define USE_errno
#define USE_h_errno

#endif

#ifdef USE_MACOS_CLASSIC

#define USE_OSErr

#endif



#include <stdio.h> /* temporary */

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_SYS_TIMES_H
#include <sys/times.h>
#endif

#ifdef HAVE_SYS_TIMEB_H
#include <sys/timeb.h>
#endif

#ifdef HAVE_SYS_TIMERS_H
#include <sys/timers.h>
#endif

#ifdef HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_SYS_FPU_H
#include <sys/fpu.h>
#endif

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef HAVE_DIRENT_H
#include <dirent.h>
#endif

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

#ifdef HAVE_GRP_H
#include <grp.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#ifdef HAVE_DLFCN_H
#include <dlfcn.h>
#endif

#ifdef HAVE_DL_H
#include <dl.h>
#endif

#ifdef HAVE_SYS_DXE_H
#include <sys/dxe.h>
#endif

#ifdef HAVE_MACH_O_DYLD_H
#include <mach-o/dyld.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_TERMIOS_H
#include <termios.h>
#endif

#ifdef HAVE_TERM_H
#include <term.h>
#endif

#ifdef HAVE_NCURSES_H
#include <ncurses.h>
#endif

#ifdef HAVE_CURSES_H
#include <curses.h>
#endif

#ifdef HAVE_PTY_H
#include <pty.h>
#endif

#ifdef HAVE_LIBUTIL_H
#include <libutil.h>
#endif

#ifdef HAVE_UTIL_H
#include <util.h>
#endif








#if 0
#include <stat.h>
#include <windows.h>
#include <io.h>
#include <float.h>
#include <fpu_control.h>
#include <os2.h>
#include <dos.h>
#include <direct.h>
#include <Retrace.h>
#include <Files.h>
#include <Finder.h>
#include <Errors.h>
#include <Folders.h>
#include <OSUtils.h>
#include <Power.h>
#include <CodeFragments.h>
#include <SIOUX.h>
#include "mac_gui.h"
#include <unix.h>
#include <wdefwin.h>
#include <tfork.h>
#include <util.h>
#endif

/*---------------------------------------------------------------------------*/

/* Determine which function for getting real time is most precise.  */

#ifdef HAVE_CLOCK_GETTIME
#define USE_clock_gettime
#else
#ifdef HAVE_GETCLOCK
#define USE_getclock
#else
#ifdef HAVE_GETSYSTEMTIME
#define USE_GetSystemTime
#else
#ifdef HAVE_GETTIMEOFDAY
#define USE_gettimeofday
#else
#ifdef HAVE_FTIME
#define USE_ftime
#else
#ifdef HAVE_TIME
#define USE_time
#endif
#endif
#endif
#endif
#endif
#endif

/* Determine which function for sleeping is most precise.  */

#ifdef HAVE_NANOSLEEP
#define USE_nanosleep
#else
#ifdef HAVE_Sleep
#define USE_Sleep
#else
#ifdef HAVE_SLEEP
#define USE_sleep
#endif
#endif
#endif

/* Determine which function for getting process time is most precise.  */

#ifdef HAVE_GETPROCESSTIMES
#define USE_GetProcessTimes
#else
#ifdef HAVE_GETRUSAGE
#define USE_getrusage
#else
#ifdef HAVE_TIMES
#define USE_times
#else
#ifdef HAVE_CLOCK
#define USE_clock
#else
#ifdef HAVE_DOSQUERYSYSINFO
#define USE_DosQuerySysInfo
#endif
#endif
#endif
#endif
#endif

#ifdef HAVE_SYSCONF
#define USE_sysconf
#endif

/* Determine which signal interface to use.  */

#ifdef HAVE_SIGACTION
#define USE_sigaction
#ifndef HAVE_SIGEMPTYSET
#undef USE_sigaction
#endif
#ifndef HAVE_SIGADDSET
#undef USE_sigaction
#endif
#ifndef HAVE_SIGPROCMASK
#undef USE_sigaction
#endif
#endif

#ifndef USE_sigaction
#ifdef HAVE_SIGNAL
#define USE_signal
#endif
#endif

/* Determine which dynamic loading interface to use.  */

#ifdef HAVE_DLOPEN
#define USE_dlopen
#else
#ifdef HAVE_SHL_LOAD
#define USE_shl_load
#else
#ifdef HAVE_LOADLIBRARY
#define USE_LoadLibrary
#else
#ifdef HAVE_DOSLOADMODULE
#define USE_DosLoadModule
#else
#ifdef HAVE_DXE_LOAD
#define USE_dxe_load
#else
#ifdef HAVE_GETDISKFRAGMENT
#define USE_GetDiskFragment
#else
#ifdef HAVE_NSLINKMODULE
#define USE_NSLinkModule
#endif
#endif
#endif
#endif
#endif
#endif
#endif

/*---------------------------------------------------------------------------*/



#ifdef HAVE_SETITIMER
#define USE_setitimer
#endif

#ifdef HAVE_GETHOSTBYNAME
#define USE_gethostbyname
#endif

#ifdef HAVE_GETSERVBYNAME
#define USE_getservbyname
#endif

#ifdef HAVE_GETSERVBYPORT
#define USE_getservbyport
#endif

#ifdef HAVE_GETPROTOBYNAME
#define USE_getprotobyname
#endif

#ifdef HAVE_GETPROTOBYNUMBER
#define USE_getprotobynumber
#endif

#ifdef HAVE_GETNETBYNAME
#define USE_getnetbyname
#endif


/*---------------------------------------------------------------------------*/

/* Determine which select interface to use.  */

#ifdef HAVE_SELECT
#define USE_select
#else
#ifdef HAVE_MSGWAITFORMULTIPLEOBJECTS
#define USE_MsgWaitForMultipleObjects
#endif
#endif

/*---------------------------------------------------------------------------*/

/* Determine which curses interface should be used.  */

#if 0
///////////////////////////////

#ifdef HAVE_TGETSTR
#define USE_TERMCAP
#define USE_CURSES
#else
#ifdef HAVE_TIGETSTR
#define USE_TERMINFO
#define USE_CURSES
#endif
#endif

#else

#define USE_CURSES

#endif

/*---------------------------------------------------------------------------*/

/* Determine which pty interface should be used.  */

#ifdef HAVE_OPENPTY
#define USE_openpty
#else
#ifdef HAVE_PTSNAME
#define USE_ptsname
#endif
#endif

/*---------------------------------------------------------------------------*/

#ifdef HAVE_HSTRERROR
#define USE_hstrerror
#endif

/*---------------------------------------------------------------------------*/



#if 0


#define USE_UNIX
#define USE_dlopen

#ifdef USE_sigaction
#define USE_sigaction_SIGINT
#endif

#ifdef USE_signal
#define USE_signal_SIGINT
#endif



#ifdef __linux__
#ifdef i386
#define USE__FPU_SETCW
#endif
#endif

#ifdef __DJGPP__
#ifdef __i386__
#define USE_DJGPP
#endif
#endif

#ifdef _MSC_VER
#ifndef __MWERKS__
#if _MSC_VER < 1000
#ifdef _M_I86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif
#else
#ifdef _M_IX86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif
#endif
#ifndef S_ISDIR
#define S_ISDIR(mode)(mode&_S_IFDIR)
#endif
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#define isatty(descr)_isatty(descr)
#define USE_autocad_gui
#endif
#endif

#ifdef USE_autocad_gui
#define RTNORM  5100
#define RTCAN  -5002
extern int acedPrompt (const char *str);
extern int acedGetString (int cronly, const char *prompt, char *result);
extern int acedGetStringB (int cronly, const char *prompt,
                           char *result, int bufsize);
extern int acedUsrBrk (void);
extern int acedCommand (int rtype, ...);
#endif

#ifdef __BORLANDC__
#ifdef _M_IX86
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#endif
#endif

#ifdef __WATCOMC__
#ifdef __386__
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#ifdef __SW_BW
#define INCLUDE_wdefwin_h
#endif
#define popen(command,mode)_popen(command,mode)
#define pclose(stream)_pclose(stream)
#endif
#endif

#ifdef __MWERKS__
#ifdef __INTEL__
#define USE_WIN32
#define USE_time
#define fileno(stream)_fileno(stream)
#define isatty(descr)_isatty(descr)
#else
#define USE_MACOS
#define USE_GetDateTime
#define USE_TickCount
#define USE_CWIDE
#define EIO (EINTR+1)
#define BUFFERED_STDOUT
#if __MWERKS__ < 0x2000
#define kPrivateCFragCopy kNewCFragCopy
#endif
#if __MWERKS__ < 0x1800
#define USE_SIOUX
#else
#define USE_mac_gui
#endif
#endif
#define EINTR 9999
#define popen(command,mode) 0
#define pclose(stream) -1
#endif

#ifdef __MINGW32__
#define USE_WIN32
#define USE_fullpath
#define USE_ftime
#endif

#ifdef __MACHTEN__
#define USE_UNIX
#endif

#ifdef __MACH__
#ifdef __APPLE__
#ifdef __ppc__
#define USE_UNIX
#define USE_NSLinkModule
#define USE_sigaction_SIGINT
#define USE_sigaction_setitimer
#define USE_openpty
#define USE_gethostbyname
#endif
#endif
#endif

#ifdef __LCC__
#ifdef _X86_
#ifdef _M_IX86
#define USE_fullpath
#define USE_ftime
#ifndef S_ISDIR
#define S_ISDIR(mode)(mode&_S_IFDIR)
#endif
#endif
#endif
#endif

#ifdef _CRAY
#ifdef _CRAY1
#define USE_UNICOS
#endif
#endif

/*---------------------------------------------------------------------------*/

/* Determine which header files to include. */

#ifdef USE_UNIX
#define USE_getrusage
#define USE_gettimeofday
#define INCLUDE_unistd_h
#define INCLUDE_pwd_h
#define INCLUDE_grp_h
#define INCLUDE_sys_types_h
#define INCLUDE_sys_time_h
#define INCLUDE_time_h
#endif

#ifdef USE_DJGPP
#define USE_gettimeofday
#define USE_times
#define USE_DOS_PATHS
#define USE_dxe_load
#define USE_control87
#endif

#ifdef USE_WIN32
#define USE_clock
#define USE_DOS
#define USE_LoadLibrary
#define USE_signal_SIGINTXXXXXX
#define USE_CreateThread
#define INCLUDE_windows_h
#define INCLUDE_io_h
#define USE_control87XXXXXXX
#define USE_GetLastError /*XXXXXXX*/
#define USE_FormatMessage
#endif

#ifdef USE_OS2
#define USE_DOS
#define USE_fullpath
#define USE_DosStartTimer
#define USE_DosLoadModule
#define INCLUDE_sys_types_h
#define INCLUDE_sys_stat_h
#define INCLUDE_signal_h
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_DOSFILEMGR
#define INCL_DOSMISC
#define INCL_DOSDATETIME
#define INCLUDE_os2_h
#endif

#ifdef USE_DOS
#define USE_DOS_PATHS
#ifndef USE_WIN32
#define INCLUDE_dos_h
#endif
#define INCLUDE_direct_h
#define INCLUDE_time_h
#endif

#ifdef USE_MACOS
#define USE_GetDiskFragment
#define USE_signal_SIGINT
#define USE_VInstall
#define INCLUDE_Retrace_h
#define INCLUDE_Files_h
#define INCLUDE_Finder_h
#define INCLUDE_Errors_h
#define INCLUDE_Folders_h
#define INCLUDE_OSUtils_h
#define INCLUDE_Power_h
#define INCLUDE_CodeFragments_h
#define INCLUDE_signal_h
#define INCLUDE_stat_h
#ifdef USE_SIOUX
#define INCLUDE_SIOUX_h
#define INCLUDE_unistd_h
#define INCLUDE_unix_h
#endif
#ifdef USE_mac_gui
#define INCLUDE_mac_gui_h
#endif
#endif

#ifdef USE_UNICOS
#define USE_gettimeofday
#define USE_times
#define USE_signal_SIGINT
#define USE_t_fork
#define INCLUDE_unistd_h
#define INCLUDE_sys_types_h
#define INCLUDE_sys_time_h
#define INCLUDE_time_h
#endif

/////////////////////////
#ifdef HAVE_SYS_FPU_H
#define INCLUDE_sys_fpu_h
#endif

#ifdef INCLUDE_sys_fpu_h
#include <sys/fpu.h>
#endif

/////////////////////////
#ifdef HAVE_FENV_H
#define INCLUDE_fenv_h
#endif

#ifdef INCLUDE_fenv_h
#include <fenv.h>
#endif





#ifdef USE_time
#define INCLUDE_time_h
#endif

#ifdef USE_ftime
#define INCLUDE_sys_types_h
#define INCLUDE_sys_timeb_h
#endif

#ifdef USE_gettimeofday
#define INCLUDE_sys_time_h
#endif

#ifdef USE_times
#define INCLUDE_sys_times_h
#endif

#ifdef USE_clock_gettime
#define INCLUDE_time_h
#endif

#ifdef USE_getclock
#define INCLUDE_sys_timers_h
#endif

#ifdef USE_getrusage
#define INCLUDE_sys_resource_h
#endif

#ifdef USE_dlopen
#define INCLUDE_dlfcn_h
#endif

#ifdef USE_shl_load
#define INCLUDE_dl_h
#endif

#ifdef USE_dxe_load
#define INCLUDE_sys_dxe_h
#endif

#ifdef USE_NSLinkModule
#define INCLUDE_mach_o_dyld_h
#endif

#ifdef USE_signal
#undef INCLUDE_signal_h
#define INCLUDE_signal_h
#endif

#ifdef USE_sigaction
#undef INCLUDE_signal_h
#define INCLUDE_signal_h
#endif

#ifdef USE_gethostbyname
#define INCLUDE_netdb_h
#endif

#ifdef USE_fullpath
#define INCLUDE_sys_stat_h
#endif

#ifdef USE_control87
#define INCLUDE_float_h
#endif

#ifdef USE__FPU_SETCW
#ifdef HAS_fpu_control_h
#define INCLUDE_fpu_control_h
#else
/*
 * Some Linux distributions don't have the file "fpu_control.h".
 * Instead of including that file we explicitly define the macros we
 * need.
 */
#ifndef _FPU_CONTROL_H
#define _FPU_CONTROL_H
#define _FPU_MASK_IM  0x01
#define _FPU_MASK_DM  0x02
#define _FPU_MASK_ZM  0x04
#define _FPU_MASK_OM  0x08
#define _FPU_MASK_UM  0x10
#define _FPU_MASK_PM  0x20
#define _FPU_DOUBLE   0x200
#define _FPU_RC_NEAREST 0x0
typedef unsigned int fpu_control_t __attribute__ ((__mode__ (__HI__)));
#define _FPU_SETCW(cw) __asm__ ("fldcw %0" : : "m" (*&cw))
#endif
#endif
#endif

#ifdef USE_t_fork
#define INCLUDE_tfork_h
#define INCLUDE_sys_wait_h
#endif

#ifdef USE_openpty
#define INCLUDE_util_h
#endif


/*---------------------------------------------------------------------------*/

/* Inclusion of header files. */

#define _STDIO_UNLOCK_CHAR_IO

#include <stdio.h>
#include <errno.h>

#ifndef ESUCCESS
#define ESUCCESS 0
#endif

#ifndef EINTR
#define EINTR -1
#endif

#define __USE_XOPEN
#include <stdlib.h>

#include <string.h>

#ifdef INCLUDE_unistd_h
#include <unistd.h>
#endif

#ifdef INCLUDE_pwd_h
#include <pwd.h>
#endif

#ifdef INCLUDE_grp_h
#include <grp.h>
#endif

#ifdef INCLUDE_dlfcn_h
#include <dlfcn.h>
#endif

#ifdef INCLUDE_dl_h
#include <dl.h>
#endif

#ifdef INCLUDE_sys_dxe_h
#include <sys/dxe.h>
#endif

#ifdef INCLUDE_mach_o_dyld_h
#include <mach-o/dyld.h>
#endif

#ifdef INCLUDE_sys_types_h
#include <sys/types.h>
#endif

#ifdef INCLUDE_sys_time_h
#include <sys/time.h>
#endif

#ifdef INCLUDE_sys_times_h
#include <sys/times.h>
#endif

#ifdef INCLUDE_sys_timeb_h
#include <sys/timeb.h>
#endif

#ifdef INCLUDE_sys_timers_h
#include <sys/timers.h>
#endif

#ifdef INCLUDE_time_h
#include <time.h>
#endif

#ifdef INCLUDE_sys_resource_h
#include <sys/resource.h>
#endif

#ifdef INCLUDE_sys_stat_h
#include <sys/stat.h>
#endif

#ifdef INCLUDE_sys_wait_h
#include <sys/wait.h>
#endif

#ifdef INCLUDE_stat_h
#include <stat.h>
#endif

#ifdef INCLUDE_signal_h
#include <signal.h>
#endif

#ifdef INCLUDE_netdb_h
#include <netdb.h>
#endif

#ifdef INCLUDE_windows_h
#include <windows.h>
#endif

#ifdef INCLUDE_io_h
#include <io.h>
#endif

#ifdef INCLUDE_float_h
#include <float.h>
#endif

#ifdef INCLUDE_fpu_control_h
#include <fpu_control.h>
#endif

#ifdef INCLUDE_os2_h
#include <os2.h>
#endif

#ifdef INCLUDE_dos_h
#include <dos.h>
#endif

#ifdef INCLUDE_direct_h
#include <direct.h>
#endif

#ifdef INCLUDE_Retrace_h
#include <Retrace.h>
#endif

#ifdef INCLUDE_Files_h
#include <Files.h>
#endif

#ifdef INCLUDE_Finder_h
#include <Finder.h>
#endif

#ifdef INCLUDE_Errors_h
#include <Errors.h>
#endif

#ifdef INCLUDE_Folders_h
#include <Folders.h>
#endif

#ifdef INCLUDE_OSUtils_h
#include <OSUtils.h>
#endif

#ifdef INCLUDE_Power_h
#include <Power.h>
#endif

#ifdef INCLUDE_CodeFragments_h
#include <CodeFragments.h>
#endif

#ifdef INCLUDE_SIOUX_h
#include <SIOUX.h>
#endif

#ifdef INCLUDE_mac_gui_h
#include "mac_gui.h"
#endif

#ifdef INCLUDE_unix_h
#include <unix.h>
#endif

#ifdef INCLUDE_wdefwin_h
#include <wdefwin.h>
#endif

#ifdef INCLUDE_tfork_h
#include <tfork.h>
#endif

#ifdef INCLUDE_util_h
#include <util.h>
#endif



#endif /* #if 0 */

/*---------------------------------------------------------------------------*/

/* Define process exit codes (see sysexits.h on many UNIX systems). */

#define ___EXIT_CODE_OK          0
#define ___EXIT_CODE_USAGE       64
#define ___EXIT_CODE_DATAERR     65
#define ___EXIT_CODE_NOINPUT     66
#define ___EXIT_CODE_NOUSER      67
#define ___EXIT_CODE_NOHOST      68
#define ___EXIT_CODE_UNAVAILABLE 69
#define ___EXIT_CODE_SOFTWARE    70
#define ___EXIT_CODE_OSERR       71
#define ___EXIT_CODE_OSFILE      72
#define ___EXIT_CODE_CANTCREAT   73
#define ___EXIT_CODE_IOERR       74
#define ___EXIT_CODE_TEMPFAIL    75
#define ___EXIT_CODE_PROTOCOL    76
#define ___EXIT_CODE_NOPERM      77
#define ___EXIT_CODE_CONFIG      78


/*---------------------------------------------------------------------------*/

/* Max length of a path, not including null. */

#define ___PATH_MAX_LENGTH 1024


/* Max length of a shell command, not including null. */

#define ___CMD_MAX_LENGTH 1024


/* Max length of an error message, not including null. */

#define ___ERR_MAX_LENGTH 1024


/*
 * Does "___alloc_mem" allocate upwards (___ALLOC_MEM_UP) or downwards
 * (___ALLOC_MEM_DOWN).  This setting only affects performance.
 */

#define ___ALLOC_MEM_UP


/* Program startup. */

typedef struct program_startup_info_struct
  {
    ___UCS2STRING *argv;
    ___UCS2STRING script_line;

#ifndef USE_WIN32

#define PROGRAM_STARTUP_INFO_INIT_OS_SPECIFIC

#endif

#ifdef USE_WIN32

    HINSTANCE hInstance;
    HINSTANCE hPrevInstance;
    LPSTR lpCmdLine;
    int nCmdShow;

#define PROGRAM_STARTUP_INFO_INIT_OS_SPECIFIC , NULL, NULL, NULL, 0

#endif
  } program_startup_info;

extern program_startup_info ___program_startup_info;


extern int ___main
   ___P((___mod_or_lnk (*linker)(___global_state_struct*)),
        ());


/* Process termination. */

extern void ___exit_process
   ___P((int status),
        ());


/* Error handling. */

/* 
 * The procedure "___display_error" is called by the runtime system to
 * send an error message to the user.
 */

extern void ___display_error
   ___P((char **msgs),
        ());


/* 
 * The procedure "___fatal_error" is called by the runtime system when
 * an unrecoverable error has occured.
 */

extern void ___fatal_error
   ___P((char **msgs),
        ());


/* Conversion of error codes to error messages. */

extern ___SCMOBJ ___os_err_code_to_string
   ___P((___SCMOBJ err),
        ());


/* Low-level memory allocation. */

/******************* should be moved to gambit.h */

#if 0
extern void *___alloc_mem
   ___P((unsigned long bytes),
        ());

extern void ___free_mem
   ___P((void *ptr),
        ());
#endif


/* Time management. */

#define ___FLOAT_TIME_REPRESENTATION

#ifdef ___FLOAT_TIME_REPRESENTATION

typedef ___F64 ___time;

#endif

#ifdef ___INT_TIME_REPRESENTATION

typedef struct ___time_struct
  {
    ___SM32 secs;
    ___SM32 nsecs;
  } ___time;

#endif

extern ___time ___time_pos_infinity;
extern ___time ___time_neg_infinity;
extern ___time ___time_zero;

extern void ___time_from_nsecs
   ___P((___time *tim,
         ___SM32 secs,
         ___SM32 nsecs),
        ());

extern void ___time_add
   ___P((___time *tim1,
         ___time tim2),
        ());

extern void ___time_subtract
   ___P((___time *tim1,
         ___time tim2),
        ());

extern ___BOOL ___time_equal
   ___P((___time tim1,
         ___time tim2),
        ());

extern ___BOOL ___time_less
   ___P((___time tim1,
         ___time tim2),
        ());

extern ___BOOL ___time_positive
   ___P((___time tim),
        ());

extern void ___time_get_current_time
   ___P((___time *tim),
        ());

extern void ___time_to_seconds
   ___P((___time tim,
         ___F64 *seconds),
        ());

extern void ___time_from_seconds
   ___P((___time *tim,
         ___F64 seconds),
        ());


/* Process times (user time, system time and real time). */

extern void ___process_times
   ___P((___F64 *user,
         ___F64 *sys,
         ___F64 *real),
        ());


/* Heartbeat interrupt handling. */

extern ___F64 ___set_heartbeat_interval
   ___P((___F64 seconds),
        ());


/* Access to OS environment variables. */

extern ___SCMOBJ ___getenv_ucs2
   ___P((___UCS2STRING name,
         ___UCS2STRING *value),
        ());

extern ___SCMOBJ ___setenv_ucs2
   ___P((___UCS2STRING name,
         ___UCS2STRING value),
        ());

extern ___SCMOBJ ___unsetenv_ucs2
   ___P((___UCS2STRING name),
        ());


//////////////////////obsolete
extern char *___getenv
   ___P((char *name),
        ());

extern ___SCMOBJ ___os_getenv
   ___P((___SCMOBJ name),
        ());

extern ___SCMOBJ ___os_setenv
   ___P((___SCMOBJ name,
         ___SCMOBJ value),
        ());

extern ___SCMOBJ ___os_environ ___PVOID;


/* Shell command. */

extern ___SCMOBJ ___os_shell_command
   ___P((___SCMOBJ cmd),
        ());


/* Dynamic loading. */

extern ___SCMOBJ ___dynamic_load
   ___P((___SCMOBJ path,
         ___SCMOBJ modname,
         void **linker),
        ());


/* Dynamic C compilation. */

extern ___BOOL ___dynamic_cc
   ___P((char *cc_cmd,
         char *ld_cmd,
         char *root_path,
         char *output_path,
         char *options_for_C_compiler,
         char *options_for_C_linker,
         ___BOOL ld_flip,
         char **errmsg),
        ());


/* Allocation of C closures. */

extern void *___make_c_closure
   ___P((___SCMOBJ proc,
         void *converter),
        ());

extern ___BOOL ___is_a_c_closure
   ___P((void *fn),
        ());

extern void ___c_closure_release
   ___P((void *c_closure),
        ());

extern void *___c_closure_self ___PVOID;


/* Virtual memory statistics. */

extern void ___vm_stats
   ___P((long *minflt,
         long *majflt),
        ());


/* Filesystem path expansion. */

extern ___SCMOBJ ___os_path_gambcdir ___PVOID;

extern ___SCMOBJ ___os_path_normalize_directory
   ___P((___SCMOBJ path),
        ());


/* Formatting of source code position. */

extern char *___format_filepos
   ___P((char *path,
         long filepos,
         ___BOOL pinpoint),
        ());


/* OS initialization/finalization. */

extern ___SCMOBJ ___setup_os ___PVOID;
extern void ___cleanup_os ___PVOID;


/* Utilities for machine encoding of characters. */

/*
 * For now a LATIN-1 encoding of characters is assumed for 'unsigned
 * char'.  This means that the mapping to and from the ISO/IEC
 * 10646-1:1993 character set is the identity function.  To support
 * other machine representations, e.g. EBCDIC, these macros would have
 * to actually translate the characters.
 */

#define ucs4_to_uchar(u)u
#define uchar_to_ucs4(c)c


/*---------------------------------------------------------------------------*/

#if 0



#if 1
#define USE_POSIX
#define USE_WIN32zzzzzzzz
#define USE_MACOSzzzzzzzz
#define USE_CURSES
#define USE_TERMINFOzzz
#define USE_TERMCAPzzzz

#define USE_gettimeofday
#define USE_select
#define USE_nanosleepzzzzzzzz
#define USE_errno

#else

#define USE_POSIXXXXXX
#define USE_WIN32
#define USE_MACOSzzzzzzzz
#define USE_CURSES
#define USE_TERMINFOzzz
#define USE_TERMCAPzzzz

#define USE_gettimeofdayXXXXXX
#define USE_selectXXXXXX
#define USE_MsgWaitForMultipleObjectsZZZZ /******************/
#define USE_nanosleepzzzzzzzz
#define USE_errnoXXXXXX
#define USE_GetLastError /**********************/
#define USE_WSAGetLastError /****************/

#endif


#ifdef INCLUDE_netdb_h
#define USE_h_errno
#ifndef sun////////////////////////////
#define USE_hstrerror
#endif
#endif




#include <stdlib.h>

#include <errno.h>


#ifdef USE_POSIX

#include <curses.h>

/*
MacOS X doesn't have this!
#include <term.h>
*/

#include <signal.h>
#include <sys/ioctl.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/time.h>

#include <termios.h>
#include <unistd.h>

#include <termios.h>

#include <sys/socket.h>
#include <netinet/in.h>

#include <dirent.h>

#endif


#ifdef USE_WIN32

#include <winsock2.h>
#include <windows.h>
#include <tchar.h>
#include <sys/types.h>
#include <sys/timeb.h>

#undef COLOR_CYAN
#undef COLOR_BLUE
#define COLOR_CYAN 6
#define COLOR_BLUE 4

#endif


#endif /* #if 0 */

/*****************************************************************************/

/* Devices. */

typedef struct ___device_group_struct
  {
    struct ___device_struct *list; /* list of devices in this group */
  } ___device_group;

#define ___NONE_KIND              0
#define ___OBJECT_KIND            1
#define ___CHARACTER_KIND         3
#define ___BYTE_KIND              7
#define ___DEVICE_KIND            15
#define ___FILE_DEVICE_KIND       (___DEVICE_KIND+16)
#define ___PROCESS_DEVICE_KIND    (___DEVICE_KIND+32)
#define ___PIPE_DEVICE_KIND ___PROCESS_DEVICE_KIND/////////////////////////
#define ___TTY_DEVICE_KIND        (___DEVICE_KIND+64)
#define ___SERIAL_DEVICE_KIND     (___DEVICE_KIND+128)
#define ___TCP_CLIENT_DEVICE_KIND (___DEVICE_KIND+256)
#define ___TCP_SERVER_KIND        (___OBJECT_KIND+512)
#define ___DIRECTORY_KIND         (___OBJECT_KIND+1024)
#define ___EVENT_QUEUE_KIND       (___OBJECT_KIND+2048)
#define ___TIMER_KIND             (___OBJECT_KIND+4096)
#define ___VECTOR_KIND            (___OBJECT_KIND+8192)
#define ___STRING_KIND            (___CHARACTER_KIND+16384)
#define ___U8VECTOR_KIND          (___BYTE_KIND+32768)

#define ___CHAR_ENCODING(x)      ((x)&(15<<0))
#define ___CHAR_ENCODING_MASK(x) ((x)&~(15<<0))
#define ___CHAR_ENCODING_ASCII   (0<<0)
#define ___CHAR_ENCODING_LATIN1  (1<<0)
#define ___CHAR_ENCODING_UTF8    (2<<0)
#define ___CHAR_ENCODING_UCS2    (3<<0)
#define ___CHAR_ENCODING_UCS2BE  (4<<0)
#define ___CHAR_ENCODING_UCS2LE  (5<<0)
#define ___CHAR_ENCODING_UCS4    (6<<0)
#define ___CHAR_ENCODING_UCS4BE  (7<<0)
#define ___CHAR_ENCODING_UCS4LE  (8<<0)
#define ___CHAR_ENCODING_NATIVE  (9<<0)

#ifdef ___BIG_ENDIAN
#define ___CHAR_ENCODING_U8  ___CHAR_ENCODING_LATIN1
#define ___CHAR_ENCODING_U16 ___CHAR_ENCODING_UCS2BE
#define ___CHAR_ENCODING_U32 ___CHAR_ENCODING_UCS4BE
#else
#define ___CHAR_ENCODING_U8  ___CHAR_ENCODING_LATIN1
#define ___CHAR_ENCODING_U16 ___CHAR_ENCODING_UCS2LE
#define ___CHAR_ENCODING_U32 ___CHAR_ENCODING_UCS4LE
#endif

#define ___CHAR_TYPE(ce) \
ce(___LATIN1,char,___UCS2,___UCS4,char)

#define ___STRING_TYPE(ce) \
ce(___LATIN1STRING,___UTF8STRING,___UCS2STRING,___UCS4STRING,char*)

#define ___CE(ce) \
ce(___CHAR_ENCODING_LATIN1, \
   ___CHAR_ENCODING_UTF8, \
   ___CHAR_ENCODING_UCS2, \
   ___CHAR_ENCODING_UCS4, \
   ___CHAR_ENCODING_NATIVE)

#define ___EOL_ENCODING(x)      ((x)&(7<<4))
#define ___EOL_ENCODING_MASK(x) ((x)&~(7<<4))
#define ___EOL_ENCODING_LF      (0<<4)
#define ___EOL_ENCODING_CR      (1<<4)
#define ___EOL_ENCODING_CRLF    (2<<4)
#define ___EOL_ENCODING_LFCR    (3<<4)

#define ___DECODE_STATE(x)      ((x)&(3<<7))
#define ___DECODE_STATE_MASK(x) ((x)&~(3<<7))
#define ___DECODE_STATE_NONE    (0<<7)
#define ___DECODE_STATE_LF      (1<<7)
#define ___DECODE_STATE_CR      (2<<7)

#define ___OPEN_STATE(x)      ((x)&(1<<9))
#define ___OPEN_STATE_MASK(x) ((x)&~(1<<9))
#define ___OPEN_STATE_OPEN    (0<<9)
#define ___OPEN_STATE_CLOSED  (1<<9)

#define ___LINE_BUFFERED(x)  ((x)<___BUFFERING)
#define ___BUFFERING_MASK(x) ((x)&~(3<<12))
#define ___NO_BUFFERING      (0<<12)
#define ___LINE_BUFFERING    (1<<12)
#define ___BUFFERING         (2<<12)

#define ___DIRECTION_RD 1
#define ___DIRECTION_WR 2

#define ___STAGE_OPEN     0
#define ___STAGE_CLOSING1 1
#define ___STAGE_CLOSING2 2
#define ___STAGE_CLOSED   3

#define ___SELECT_PASS_CHECK 0
#define ___SELECT_PASS_1     1
#define ___SELECT_PASS_2     2
#define ___SELECT_PASS_3     3

#define ___STREAM_DEFAULT_OPTIONS(ice,iee,ib,oce,oee,ob) \
___FIX((ice+iee+ib)+((oce+oee+ob)<<14))

typedef struct ___device_struct
  {
    void *vtbl;

#ifdef USE_PUMPS
    LONG refcount;                 /* device structure is released when zero */
#else
    int refcount;                  /* device structure is released when zero */
#endif

    ___device_group *group;        /* device group this device belongs to */
    struct ___device_struct *prev; /* bidirectional list pointer to previous */
    struct ___device_struct *next; /* bidirectional list pointer to next */
    int direction;                 /* ___DIRECTION_RD and/or ___DIRECTION_WR */
    int read_stage;                /* ___STAGE_OPEN ... ___STAGE_CLOSED */
    int write_stage;               /* ___STAGE_OPEN ... ___STAGE_CLOSED */
    int select_step;               /* for implementing "___device_select" */
  } ___device;

typedef struct ___device_select_state_struct
  {
    ___device **devs; /* devices to select on */

    ___time timeout; /* absolute timeout of the select */
    ___F64 relative_timeout; /* relative timeout of the select in seconds */
    ___BOOL timeout_reached; /* did select reach the timeout? */

#ifdef USE_select
    int highest_fd_plus_1;
    fd_set readfds;
    fd_set writefds;
    fd_set exceptfds;
#endif

#ifdef USE_MsgWaitForMultipleObjects
#if 0
    DWORD timeout;/*********************/
#endif
    int timeout_dev_pos;
    DWORD message_queue_mask;
    int message_queue_dev_pos;
    int nb_wait_objs;
    HANDLE wait_objs_buffer[MAXIMUM_WAIT_OBJECTS];
    int wait_obj_to_dev_pos[MAXIMUM_WAIT_OBJECTS];
#endif

#ifdef USE_MACOS
    /*********************/
#endif
  } ___device_select_state;

typedef struct ___device_vtbl_struct
  {
#define ___device_kind(self) \
___CAST(___device_vtbl*,(self)->vtbl)->kind(self)

    int (*kind) ___P((___device *self),());

#define ___device_select_virt(self,for_writing,i,pass,state) \
___CAST(___device_vtbl*,(self)->vtbl)->select_virt(self,for_writing,i,pass,state)

    ___SCMOBJ (*select_virt)
       ___P((___device *self,
             ___BOOL for_writing,
             int i,
             int pass,
             ___device_select_state *state),
            ());

#define ___device_release_virt(self) \
___CAST(___device_vtbl*,(self)->vtbl)->release_virt(self)

    ___SCMOBJ (*release_virt)
       ___P((___device *self),
            ());

#define ___device_flush_write_virt(self) \
___CAST(___device_vtbl*,(self)->vtbl)->flush_write_virt(self)

    ___SCMOBJ (*flush_write_virt)
       ___P((___device *self),
            ());

#define ___device_close_virt(self,direction) \
___CAST(___device_vtbl*,(self)->vtbl)->close_virt(self,direction)

    ___SCMOBJ (*close_virt)
       ___P((___device *self,
             int direction),
            ());
  } ___device_vtbl;

/* Timer device. */

typedef struct ___device_timer_struct
  {
    ___device base;
    ___time expiry;
  } ___device_timer;

typedef struct ___device_timer_vtbl_struct
  {
    ___device_vtbl base;
  } ___device_timer_vtbl;

extern ___SCMOBJ ___device_timer_setup
   ___P((___device_timer **dev,
         ___device_group *dgroup),
        ());

extern void ___device_timer_set_expiry
   ___P((___device_timer *dev,
         ___time expiry),
        ());

/* Byte stream device. */

typedef int ___stream_index;

typedef struct ___device_stream_struct
  {
    ___device base;

#ifdef USE_PUMPS
    ___device_stream_pump *read_pump;
    ___device_stream_pump *write_pump;
#endif
  } ___device_stream;

typedef struct ___device_stream_vtbl_struct
  {
    ___device_vtbl base;

#define ___device_stream_select_raw_virt(self,for_writing,i,pass,state) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->select_raw_virt(self,for_writing,i,pass,state)

    ___SCMOBJ (*select_raw_virt)
       ___P((___device_stream *self,
             ___BOOL for_writing,
             int i,
             int pass,
             ___device_select_state *state),
            ());

#define ___device_stream_release_raw_virt(self) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->release_raw_virt(self)

    ___SCMOBJ (*release_raw_virt)
       ___P((___device_stream *self),
            ());

#define ___device_stream_flush_write_raw_virt(self) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->flush_write_raw_virt(self)

    ___SCMOBJ (*flush_write_raw_virt)
       ___P((___device_stream *self),
            ());

#define ___device_stream_seek_raw_virt(self,pos,whence) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->seek_raw_virt(self,pos,whence)

    ___SCMOBJ (*seek_raw_virt)
       ___P((___device_stream *self,
             ___stream_index pos,
             int whence),
            ());

#define ___device_stream_read_raw_virt(self,buf,len,len_done) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->read_raw_virt(self,buf,len,len_done)

    ___SCMOBJ (*read_raw_virt)
       ___P((___device_stream *self,
             ___U8 *buf,
             ___stream_index len,
             ___stream_index *len_done),
            ());

#define ___device_stream_write_raw_virt(self,buf,len,len_done) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->write_raw_virt(self,buf,len,len_done)

    ___SCMOBJ (*write_raw_virt)
       ___P((___device_stream *self,
             ___U8 *buf,
             ___stream_index len,
             ___stream_index *len_done),
            ());

#define ___device_stream_width(self) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->width(self)

    ___SCMOBJ (*width)
       ___P((___device_stream *self),
            ());

#define ___device_stream_default_options(self) \
___CAST(___device_stream_vtbl*,(self)->base.vtbl)->default_options(self)

    ___SCMOBJ (*default_options)
       ___P((___device_stream *self),
            ());
  } ___device_stream_vtbl;

extern ___SCMOBJ ___device_stream_seek
   ___P((___device_stream *self,
         ___stream_index pos,
         int whence),
        ());

extern ___SCMOBJ ___device_stream_read
   ___P((___device_stream *self,
         ___U8 *buf,
         ___stream_index len,
         ___stream_index *len_done),
        ());

extern ___SCMOBJ ___device_stream_write
   ___P((___device_stream *self,
         ___U8 *buf,
         ___stream_index len,
         ___stream_index *len_done),
        ());

extern ___SCMOBJ ___device_stream_setup
   ___P((___device_stream *dev,
         ___device_group *dgroup,
         int direction,
         int pumps_on),
        ());


extern ___SCMOBJ ___device_stream_setup_from_fd
   ___P((___device_stream **dev,
         ___device_group *dgroup,
         int fd,
         int type,
         int direction),
        ());

extern ___SCMOBJ ___device_stream_setup_from_path
   ___P((___device_stream **dev,
         ___device_group *dgroup,
         char *path,
         int flags,
         int mode),
        ());


#if 0
/* Tty stream device. */

typedef struct ___device_tty_struct
  {
    ___device_stream base;
    tty t;
  } ___device_tty;

typedef struct ___device_tty_vtbl_struct
  {
    ___device_stream_vtbl base;
  } ___device_tty_vtbl;

extern ___SCMOBJ ___device_tty_open
   ___P((___device_tty **dev,
         ___device_group *dgroup,
         int fd,
         int direction),
        ());
#endif




extern ___SCMOBJ ___device_group_setup
   ___P((___device_group **dgroup),
        ());

extern void ___device_group_cleanup
   ___P((___device_group *dgroup),
        ());





extern ___SCMOBJ ___device_select
   ___P((___device **devs,
         int nb_read_devs,
         int nb_write_devs,
         ___time timeout),
        ());

extern ___SCMOBJ ___device_flush_write
   ___P((___device *self),
        ());

extern ___SCMOBJ ___device_close
   ___P((___device *self,
         int direction),
        ());

extern ___SCMOBJ ___device_cleanup
   ___P((___device *self),
        ());




/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Device operations. */

extern ___SCMOBJ ___os_device_kind
   ___P((___SCMOBJ dev),
        ());

extern ___SCMOBJ ___os_device_force_output
   ___P((___SCMOBJ dev),
        ());

extern ___SCMOBJ ___os_device_close
   ___P((___SCMOBJ dev,
         ___SCMOBJ direction),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Stream device operations. */

extern ___SCMOBJ ___os_device_stream_seek
   ___P((___SCMOBJ dev,
         ___SCMOBJ pos,
         ___SCMOBJ whence),
        ());

extern ___SCMOBJ ___os_device_stream_read
   ___P((___SCMOBJ dev,
         ___SCMOBJ buffer,
         ___SCMOBJ lo,
         ___SCMOBJ hi),
        ());

extern ___SCMOBJ ___os_device_stream_write
   ___P((___SCMOBJ dev,
         ___SCMOBJ buffer,
         ___SCMOBJ lo,
         ___SCMOBJ hi),
        ());

extern ___SCMOBJ ___os_device_stream_width
   ___P((___SCMOBJ dev),
        ());

extern ___SCMOBJ ___os_device_stream_default_options
   ___P((___SCMOBJ dev),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening a predefined device (stdin, stdout, stderr, console, etc). */

extern ___SCMOBJ ___os_device_stream_open_predefined
   ___P((___SCMOBJ index,
         ___SCMOBJ flags),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening a path. */

extern ___SCMOBJ ___os_device_stream_open_path
   ___P((___SCMOBJ path,
         ___SCMOBJ flags,
         ___SCMOBJ mode),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening a process. */

extern ___SCMOBJ ___os_device_stream_open_process
   ___P((___SCMOBJ path_and_args,
         ___SCMOBJ environment,
         ___SCMOBJ options),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening a TCP/IP client. */

extern ___SCMOBJ ___os_device_tcp_client_open
   ___P((___SCMOBJ server_addr,
         ___SCMOBJ port_num,
         ___SCMOBJ options),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening and reading a TCP/IP server. */

extern ___SCMOBJ ___os_device_tcp_server_open
   ___P((___SCMOBJ port_num,
         ___SCMOBJ backlog,
         ___SCMOBJ options),
        ());

extern ___SCMOBJ ___os_device_tcp_server_read
   ___P((___SCMOBJ dev),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Opening and reading a directory. */

extern ___SCMOBJ ___os_device_directory_open_path
   ___P((___SCMOBJ path,
         ___SCMOBJ ignore_hidden),
        ());

extern ___SCMOBJ ___os_device_directory_read
   ___P((___SCMOBJ dev),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Tty device operations. */

extern ___SCMOBJ ___os_device_tty_type_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ term_type,
         ___SCMOBJ emacs_bindings),
        ());

extern ___SCMOBJ ___os_device_tty_text_attributes_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ input,
         ___SCMOBJ output),
        ());

extern ___SCMOBJ ___os_device_tty_history
   ___P((___SCMOBJ dev),
        ());

extern ___SCMOBJ ___os_device_tty_history_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ history),
        ());

extern ___SCMOBJ ___os_device_tty_max_history_length_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ max_length),
        ());

extern ___SCMOBJ ___os_device_tty_paren_balance_duration_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ duration),
        ());

extern ___SCMOBJ ___os_device_tty_mode_set
   ___P((___SCMOBJ dev,
         ___SCMOBJ mode),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Waiting for I/O to become possible on a set of devices. */

extern ___SCMOBJ ___os_condvar_select
   ___P((___SCMOBJ run_queue,
         ___SCMOBJ timeout),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/*
 * Decoding and encoding of a buffer of Scheme characters to a buffer
 * of bytes.
 */

extern ___SCMOBJ ___os_port_decode_chars
   ___P((___SCMOBJ port,
         ___SCMOBJ eof),
        ());

extern ___SCMOBJ ___os_port_encode_chars
   ___P((___SCMOBJ port),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to file information. */

extern ___SCMOBJ ___os_file_info
   ___P((___SCMOBJ path,
         ___SCMOBJ chase),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to user information. */

extern ___SCMOBJ ___os_user_info
   ___P((___SCMOBJ user),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to group information. */

extern ___SCMOBJ ___os_group_info
   ___P((___SCMOBJ group),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to host information. */

extern ___SCMOBJ ___os_host_info
   ___P((___SCMOBJ host),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to service information. */

extern ___SCMOBJ ___os_service_info
   ___P((___SCMOBJ service,
         ___SCMOBJ protocol),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to protocol information. */

extern ___SCMOBJ ___os_protocol_info
   ___P((___SCMOBJ protocol),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

/* Access to network information. */

extern ___SCMOBJ ___os_network_info
   ___P((___SCMOBJ network),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

extern ___SCMOBJ ___os_create_directory
   ___P((___SCMOBJ path,
         ___SCMOBJ mode),
        ());

extern ___SCMOBJ ___os_create_fifo
   ___P((___SCMOBJ path,
         ___SCMOBJ mode),
        ());

extern ___SCMOBJ ___os_create_link
   ___P((___SCMOBJ path1,
         ___SCMOBJ path2),
        ());

extern ___SCMOBJ ___os_create_symbolic_link
   ___P((___SCMOBJ path1,
         ___SCMOBJ path2),
        ());

extern ___SCMOBJ ___os_delete_directory
   ___P((___SCMOBJ path),
        ());

extern ___SCMOBJ ___os_set_current_directory
   ___P((___SCMOBJ path),
        ());

extern ___SCMOBJ ___os_rename_file
   ___P((___SCMOBJ path1,
         ___SCMOBJ path2),
        ());

extern ___SCMOBJ ___os_copy_file
   ___P((___SCMOBJ path1,
         ___SCMOBJ path2),
        ());

extern ___SCMOBJ ___os_delete_file
   ___P((___SCMOBJ path),
        ());

/*   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   */

#endif

